#!/usr/local/bin/ruby
#
# file name: wps_list_cgi.rb
#
#   cgi for WebPmSheet that list table.
#    
#
#   1.00 2014-01-08 S.Yamane created
#
#
######################################################################
require 'yaml'
require 'tempfile'
require 'fileutils'
require 'cgi'
require 'cgi/session'
require 'rexml/document'
require 'time'
require '../lib/pharma_db_lib'


YML_PATH = '../conf/wps_list.yml'

def double_escape(str)
  str = str.gsub(/['"\\]/) {|ch| ch + ch }
  return str
end
#
def wps_list_conf(table)

  if ( table == nil || table == "") then
    STDERR.print "wps_list_cgi.rb Error: set table table=",table,"\n"
    exit
  end

  yaml_data = File.read(YML_PATH)
  dds = YAML.load(yaml_data)
	STDERR.print "dds=",dds,"\n"

  if ( dds[table] == nil ) then
      STDERR.print "wps_list_cgi.rb: wps_list_conf :Error no parameter at #{table}!!\n"
      exit 1
  end

  h_data = dds[table]
  remark = h_data["remark"]
  disp_keys = h_data["disp_keys"]
  disp_xml_tags = h_data["disp_xml_tags"]

  d_disp_keys = disp_keys.split(",")
  d_disp_xml_tags = disp_xml_tags.split(",")

  return remark,d_disp_keys,d_disp_xml_tags
end
#
#def get_wps_list( d_disp_keys, table )

#   colums = d_disp_keys.join(",")
#   colums += ",xml_data"

def get_wps_list(  table )

   sql_cmd =<<-SQL
    select  * from #{table}
    ;
   SQL

   datas = PharmaDbLib.exec_sql(sql_cmd)   

   return  datas
end

# key で検索した結果を返す。
# d_keys { key1: aaa, key2: bbb }
def get_wps_data( table, keys )
	STDERR.print keys,"\n"

   h_keys = Hash.new()
   d_keys = keys.split(",")
   d_keys.each{ |dd|
     key,value = dd.split(":")
     if ( key == nil || value == nil )then
        STDERR.print "get_wps_data: keys error =",keys,"\n"
        exit
     end
     key.strip!()
     value.strip!()
     h_keys[key] = value
   }

   where = "1=1 "
   #for key in d_keys
   h_keys.each{ |key, value|
      where += " and #{key} = '#{value}'"
   }      

   sql_cmd =<<-SQL
     select  xml_data from #{table}
     where #{where}
    ;
   SQL

	STDERR.print sql_cmd

   xml_datas = PharmaDbLib.exec_sql(sql_cmd)   

   return xml_datas
end
#
#
def help( flag )

  
  STDERR.print <<-END
  flag = #{flag}

   flag=get_conf table=test
     # get wps_list parmater
     remark,d_disp_keys,d_disp_xml_tags = wps_list_conf(table)

   flag=list_data  table=machine_data
     # list data 
     datas = get_wps_list( table )

   flag=data table=machine_data keys=product_type:test_BB,process:test-Process_B
     # get data
     xml_datas = get_wps_data( table, d_keys )

  END

end
#
#
#########################################################
#
# main
#
#  uid=13001 password=yamane
#
#########################################################


PharmaDbLib.init()

cgi = CGI.new

flag = cgi['flag']
table = cgi['table']
keys = cgi['keys']

print cgi.header("content-type"=>"text/html","charset"=>"UTF-8")

case flag
when 'get_conf'
     remark,d_disp_keys,d_disp_xml_tags = wps_list_conf(table)
	print "remark=",remark,"\n"
	print "d_disp_keys=",d_disp_keys,"\n"
	print "d_disp_xml_tags=",d_disp_xml_tags,"\n"
	exit
when 'list_data'
     datas = get_wps_list( table )
	print datas
	exit
when 'data'
     STDERR.print "keys=",keys,"\n" 
     xml_datas = get_wps_data( table, keys )
	print xml_datas
	exit
else
     help(flag)
end

